# TODO: TQt dialog [BR: pkgconfig(tqt) or pkgconfig(tqt-mt), tqmoc tool]
#
# Conditional build:
%bcond_with	efl	# EFL dialog
%bcond_without	fltk	# FLTK dialog
%bcond_without	gtk2	# GTK+ 2 dialog
%bcond_without	gnome3	# GNOME 3 dialog
%bcond_without	qt4	# Qt4 dialog
%bcond_without	qt5	# Qt5 dialog
#
Summary:	Simple PIN or passphrase entry dialogs
Summary(pl.UTF-8):	Proste kontrolki dialogowe do wpisywania PIN-ów lub haseł
Name:		pinentry
Version:	1.2.1
Release:	1
License:	GPL v2+
Group:		Applications
Source0:	ftp://ftp.gnupg.org/gcrypt/pinentry/%{name}-%{version}.tar.bz2
# Source0-md5:	be9b0d4bb493a139d2ec20e9b6872d37
Patch0:		%{name}-info.patch
URL:		http://www.gnupg.org/
%{?with_qt5:BuildRequires:	Qt5Core-devel >= 5}
%{?with_qt5:BuildRequires:	Qt5Gui-devel >= 5}
%{?with_qt5:BuildRequires:	Qt5Widgets-devel >= 5}
%{?with_qt5:BuildRequires:	Qt5X11Extras-devel >= 5}
%{?with_qt4:BuildRequires:	QtCore-devel >= 4}
%{?with_qt4:BuildRequires:	QtGui-devel >= 4}
BuildRequires:	autoconf >= 2.69
BuildRequires:	automake >= 1:1.14
%{?with_efl:BuildRequires:	elementary-devel >= 1.18}
%{?with_fltk:BuildRequires:	fltk-devel >= 1.3}
BuildRequires:	gettext-tools
%{?with_gnome3:BuildRequires:	gcr-devel >= 3}
%{?with_gnome3:BuildRequires:	gcr-ui-devel >= 3}
%{?with_gtk2:BuildRequires:	gtk+2-devel >= 2:2.12.0}
%{?with_qt5:BuildRequires:	kf5-kwayland-devel >= 5.60}
BuildRequires:	libassuan-devel >= 1:2.1.0
BuildRequires:	libcap-devel
BuildRequires:	libgpg-error-devel >= 1.16
BuildRequires:	libstdc++-devel
BuildRequires:	ncurses-devel
BuildRequires:	pkgconfig
%{?with_qt4:BuildRequires:	qt4-build}
%{?with_qt5:BuildRequires:	qt5-build}
BuildRequires:	texinfo
Requires:	libassuan >= 1:2.1.0
Requires:	libgpg-error >= 1.16
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This is a collection of simple PIN or passphrase entry dialogs which
utilize the Assuan protocol as described by the aegypten project; see
http://www.gnupg.org/aegypten/ for details. Base package contains
curses-based dialog.

%description -l pl.UTF-8
Jest to zestaw prostych kontrolek dialogowych do wpisywania PIN-ów lub
haseł, używające protokołu Assuan opisanego w projekcie aegypten;
więcej szczegółów pod adresem http://www.gnupg.org/aegypten/.
Podstawowy pakiet zawiera kontrolkę opartą na curses.

%package emacs
Summary:	Simple PIN or passphrase entry dialog for Emacs
Summary(pl.UTF-8):	Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł dla Emacsa
Group:		Applications
Requires:	emacs
Requires:	libassuan >= 1:2.1.0
Requires:	libgpg-error >= 1.16

%description emacs
Simple PIN or passphrase entry dialog for Emacs.

%description emacs -l pl.UTF-8
Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł dla Emacsa.

%package efl
Summary:	Simple PIN or passphrase entry dialog using EFL
Summary(pl.UTF-8):	Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł wykorzystująca bibliotekę EFL
Group:		X11/Applications
Requires:	elementary-libs >= 1.18
Requires:	libassuan >= 1:2.1.0
Requires:	libgpg-error >= 1.16

%description efl
Simple PIN or passphrase entry dialog using EFL.

%description efl -l pl.UTF-8
Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł
wykorzystująca bibliotekę EFL.

%package fltk
Summary:	Simple PIN or passphrase entry dialog using FLTK
Summary(pl.UTF-8):	Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł wykorzystująca bibliotekę FLTK
Group:		X11/Applications
Requires:	fltk >= 1.3
Requires:	libassuan >= 1:2.1.0
Requires:	libgpg-error >= 1.16

%description fltk
Simple PIN or passphrase entry dialog using FLTK.

%description fltk -l pl.UTF-8
Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł
wykorzystująca bibliotekę FLTK.

%package gnome3
Summary:	Simple PIN or passphrase entry dialog for GNOME 3
Summary(pl.UTF-8):	Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł dla GNOME 3
Group:		X11/Applications
Requires:	libassuan >= 1:2.1.0
Requires:	libgpg-error >= 1.16

%description gnome3
Simple PIN or passphrase entry dialog for GNOME 3.

%description gnome3 -l pl.UTF-8
Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł dla GNOME 3.

%package gtk2
Summary:	Simple PIN or passphrase entry dialog for GTK+ 2
Summary(pl.UTF-8):	Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł dla GTK+ 2
Group:		X11/Applications
Requires:	gtk+2 >= 2:2.12.0
Requires:	libassuan >= 1:2.1.0
Requires:	libgpg-error >= 1.16

%description gtk2
Simple PIN or passphrase entry dialog for GTK+ 2.

%description gtk2 -l pl.UTF-8
Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł dla GTK+ 2.

%package qt4
Summary:	Simple PIN or passphrase entry dialog for Qt4
Summary(pl.UTF-8):	Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł dla Qt4
Group:		X11/Applications
Requires:	libassuan >= 1:2.1.0
Requires:	libgpg-error >= 1.16

%description qt4
Simple PIN or passphrase entry dialog for Qt4.

%description qt4 -l pl.UTF-8
Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł dla Qt4.

%package qt5
Summary:	Simple PIN or passphrase entry dialog for Qt5
Summary(pl.UTF-8):	Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł dla Qt5
Group:		X11/Applications
Requires:	kf5-kwayland >= 5.60
Requires:	libassuan >= 1:2.1.0
Requires:	libgpg-error >= 1.16

%description qt5
Simple PIN or passphrase entry dialog for Qt5.

%description qt5 -l pl.UTF-8
Prosta kontrolka dialogowa do wpisywania PIN-ów lub haseł dla Qt5.

%prep
%setup -q
%patch0 -p1

%if 0
cd qt4
%{_bindir}/moc-qt4 pinentrydialog.h  -o pinentrydialog.moc
%{_bindir}/moc-qt4 pinentryconfirm.h -o pinentryconfirm.moc
%{_bindir}/moc-qt4 qsecurelineedit.h -o qsecurelineedit.moc
cd ..
%endif

%build
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
CPPFLAGS="%{rpmcppflags} -I/usr/include/ncurses"

%configure \
	--enable-maintainer-mode \
	--disable-libsecret \
	--enable-fallback-curses \
	--enable-pinentry-curses \
	--enable-pinentry-efl%{!?with_efl:=no} \
	--enable-pinentry-emacs \
	--enable-pinentry-fltk%{!?with_fltk:=no} \
	--enable-pinentry-gnome3%{!?with_gnome3:=no} \
	--enable-pinentry-gtk2%{!?with_gtk2:=no} \
	--enable-pinentry-qt%{!?with_qt5:=no} \
	--enable-pinentry-qt4%{!?with_qt4:=no} \
	--enable-pinentry-tty

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT
%if %{with qt5}
%{__mv} $RPM_BUILD_ROOT%{_bindir}/pinentry-qt{,5}
%endif

%{__rm} $RPM_BUILD_ROOT%{_bindir}/pinentry
cat >$RPM_BUILD_ROOT%{_bindir}/pinentry <<'EOF'
#!/bin/sh

if [ -n "$PINENTRY_PROGRAM" ]; then
	exec $PINENTRY_PROGRAM "$@"
elif [ -z "$DISPLAY" ]; then
	exec %{_bindir}/pinentry-curses "$@"
elif [ -x %{_bindir}/pinentry-gnome3 ]; then
	exec %{_bindir}/pinentry-gnome3 "$@"
elif [ -x %{_bindir}/pinentry-gtk-2 ]; then
	exec %{_bindir}/pinentry-gtk-2 "$@"
elif [ -x %{_bindir}/pinentry-gtk ]; then
	exec %{_bindir}/pinentry-gtk "$@"
elif [ -x %{_bindir}/pinentry-qt5 ]; then
	exec %{_bindir}/pinentry-qt5 "$@"
elif [ -x %{_bindir}/pinentry-qt4 ]; then
	exec %{_bindir}/pinentry-qt4 "$@"
elif [ -x %{_bindir}/pinentry-qt ]; then
	exec %{_bindir}/pinentry-qt "$@"
elif [ -x %{_bindir}/pinentry-fltk ]; then
	exec %{_bindir}/pinentry-fltk "$@"
elif [ -x %{_bindir}/pinentry-efl ]; then
	exec %{_bindir}/pinentry-efl "$@"
else
	exec %{_bindir}/pinentry-curses "$@"
fi
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/postshell
-/usr/sbin/fix-info-dir -c %{_infodir}

%postun	-p /sbin/postshell
-/usr/sbin/fix-info-dir -c %{_infodir}

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog NEWS README THANKS TODO
%attr(755,root,root) %{_bindir}/pinentry
%attr(755,root,root) %{_bindir}/pinentry-curses
%attr(755,root,root) %{_bindir}/pinentry-tty
%{_infodir}/pinentry.info*

%if %{with efl}
%files efl
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/pinentry-efl
%endif

%files emacs
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/pinentry-emacs

%if %{with fltk}
%files fltk
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/pinentry-fltk
%endif

%if %{with gnome3}
%files gnome3
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/pinentry-gnome3
%endif

%if %{with gtk2}
%files gtk2
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/pinentry-gtk-2
%endif

%if %{with qt4}
%files qt4
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/pinentry-qt4
%endif

%if %{with qt5}
%files qt5
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/pinentry-qt5
%endif
%changelog
* Wed Aug 24 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/pinentry.git;a=log;h=master

* Wed Aug 24 2022 Jan Palus <atler@pld-linux.org> c191f12
- up to 1.2.1

* Sat Sep 04 2021 Jakub Bogusz <qboosh@pld-linux.org> b01b3b2
- added qt4 patch (try with some adjustments for Qt4 compatibility)

* Sun Aug 29 2021 Jan Palus <atler@pld-linux.org> 14054df
- fractional rel until upstream devs decide on fate of qt4 variant

* Thu Aug 26 2021 Jan Palus <atler@pld-linux.org> 937057f
- up to 1.2.0

* Wed Jan 27 2021 Jan Palus <atler@pld-linux.org> b99c9fc
- upstream patch to fix build against qt4; rel 2

* Fri Jan 22 2021 Jan Palus <atler@pld-linux.org> 0ddd263
- drop R: gtk+2 from gnome3

* Fri Jan 22 2021 Jan Palus <atler@pld-linux.org> 6d2d760
- remove types patch dropped from spec in 0a2f23f

* Fri Jan 22 2021 Jan Palus <atler@pld-linux.org> 54ee0da
- up to 1.1.1

* Sat Jun 09 2018 Jan Rękorajski <baggins@pld-linux.org> 27c19f6
- disable libsecret as it makes pinentry require gnome-keyring to work
- rel 3

* Wed Dec 06 2017 Jakub Bogusz <qboosh@pld-linux.org> e199b8d
- added missing format patch, release 2

* Tue Dec 05 2017 Jakub Bogusz <qboosh@pld-linux.org> bfd3c10
- updated to 1.1.0, added -fltk dialog

* Mon Nov 28 2016 Jakub Bogusz <qboosh@pld-linux.org> 7c75284
- updated to 1.0.0

* Thu Jun 23 2016 Jakub Bogusz <qboosh@pld-linux.org> 2ecfd7a
- updated to 0.9.7

* Sat Sep 19 2015 Jakub Bogusz <qboosh@pld-linux.org> 249a488
- updated to 0.9.6
- added qt5 version (build qt version both for qt4 and qt5)

* Sat Jul 04 2015 Jakub Bogusz <qboosh@pld-linux.org> 93daecd
- updated to 0.9.5
- dropped obsolete system-assuan patch

* Sat Jun 13 2015 Jakub Bogusz <qboosh@pld-linux.org> 046a165
- updated to 0.9.4
- added gnome3 dialog

* Wed May 13 2015 Jakub Bogusz <qboosh@pld-linux.org> 27b0f63
- updated to 0.9.2
- updated info patch
- added link patch (fixes build with --as-needed)

* Tue Apr 07 2015 Jakub Bogusz <qboosh@pld-linux.org> 6a174f6
- updated to 0.9.1
- removed obsolete doc patch

* Sun Mar 01 2015 Elan Ruusamäe <glen@delfi.ee> 8e0e5f8
- x32 rebuild
- release 2 (by relup.sh)

* Sun Dec 28 2014 Jan Rękorajski <baggins@pld-linux.org> 6c7d65f
- updated gettext BR

